#include "internal.h"

/* TODO FIXME XXX
 *
 * internal_is_counter:
 *
 * This silly implementation IS NOT THREAD SAFE by any measure.
 * We should be using TLS, but that's not portable. We probably
 * could play with compiler macros to use TLS where available,
 * backtrace(3) where available, and this silly implementation
 * when other options have failed.
 */


static int internal = 0;

extern char *wrapped_functions[];



void
internal_set(void)
{
	internal += 1;
}



void
internal_unset(void)
{
	internal -= 1;
}



#define _GNU_SOURCE
#include <string.h>	/* memmem */

#include <execinfo.h>	/* backtrace, backtrace_symbols */
#include <stdlib.h>	/* backtrace, backtrace_symbols */

static int
internal_is_backtrace(void)
{
	void *buffer[100];
	char **strings;
	char *self;
	int n, i, j;
	int wrapped = 0;

	n = backtrace(buffer, 100);
	strings = backtrace_symbols(buffer, n);
	for (i = 0; i < n; i++) {
		self = memmem(strings[i], strlen(strings[i]),
				"condnet.so(", 11);
		if (! self) {
			continue;
		}

		self += 11;
		for (j = 0; wrapped_functions[j]; j++) {
			if (strncmp(self, wrapped_functions[j],
						strlen(wrapped_functions[j])) == 0) {
				wrapped += 1;
			}
		}
	}

	free(strings);

	return wrapped >= 2;
}



static int
internal_is_counter(void)
{
	return internal > 0;
}



int
internal_is(void)
{
	return internal_is_backtrace();
}
